from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
import matplotlib.pyplot as plt
import requests,sys,os,traceback,matplotlib,webbrowser,xlwt
matplotlib.use('Qt5Agg')

#https://wis.qq.com/weather/common?weather_type=observe|forecast_1h|forecast_24h|index|alarm|limit|tips|air|rise&source=pc&province=&city=

位置=requests.get("https://ip.tool.lu").text.split()
省份=位置[4].replace("省","")
城市=位置[5].replace("市","")
接口=f"https://wis.qq.com/weather/common?weather_type=observe|forecast_24h|forecast_1h|air|rise|limit|index&source=pc&province={省份}&city={城市}"
#接口=f"https://wis.qq.com/weather/common?weather_type=observe&source=pc&province={省份}&city={城市}"
城市列表={
    "北京":["北京"],
    "上海":["上海"],
    "天津":["天津"],
    "重庆":["重庆"],
    "河北":["石家庄","唐山","秦皇岛","邯郸","邢台","保定","张家口","承德","沧州","廊坊","衡水"],
    "山西":["太原","大同","阳泉","长治","晋城","朔州","晋中","运城","忻州","临汾","吕梁"],
    "内蒙古":["呼和浩特","包头","乌海","赤峰","通辽","鄂尔多斯","呼伦贝尔","巴彦淖尔","乌兰察布","锡林郭勒盟","阿拉善盟","兴安盟"],
    "江苏":["南京","无锡","徐州","常州","苏州","南通","连云港","淮安","盐城","扬州","镇江","泰州","宿迁"],
    "安徽":["合肥","芜湖","蚌埠","淮南","马鞍山","淮北","铜陵","安庆","黄山","滁州","阜阳","宿州","巢湖","六安","亳州","池州","宣城"],
    "山东":["济南","青岛","淄博","枣庄","东营","潍坊","烟台","威海","济宁","泰安","日照","莱芜","临沂","德州","聊城","滨州","菏泽"],
    "辽宁":["沈阳","大连","鞍山","抚顺","本溪","丹东","锦州","营口","阜新","辽阳","盘锦","铁岭","朝阳","葫芦岛"],
    "吉林":["长春","吉林","四平","辽源","通化","白山","松原","白城","延边州"],
    "黑龙江":["哈尔滨","齐齐哈尔","鸡西","鹤岗","双鸭山","大庆","伊春","牡丹江","佳木斯","七台河","黑河","绥化","大兴安岭"],
    "浙江":["杭州","宁波","温州","嘉兴","湖州","绍兴","金华","衢州","舟山","台州","丽水"],
    "江西":["南昌","景德镇","萍乡","九江","新余","鹰潭","赣州","吉安","宜春","抚州","上饶"],
    "福建":["福州","厦门","莆田","三明","泉州","漳州","南平","龙岩","宁德"],
    "湖北":["武汉","黄石","襄樊","十堰","荆州","宜昌","荆门","鄂州","孝感","黄冈","咸宁","随州","恩施州","仙桃","天门","潜江"],
    "湖南":["长沙","株洲","湘潭","衡阳","邵阳","岳阳","常德","张家界","益阳","郴州","永州","怀化","娄底","湘西州"],
    "河南":["郑州","开封","洛阳","平顶山","焦作","鹤壁","新乡","安阳","濮阳","许昌","漯河","三门峡","南阳","商丘","信阳","周口","驻马店","济源"],
    "广东":["广州","深圳","珠海","汕头","韶关","河源","梅州","惠州","汕尾","东莞","中山","江门","佛山","阳江","湛江","茂名","肇庆","清远","潮州","揭阳","云浮"],
    "广西":["南宁","柳州","桂林","梧州","北海","防城港","钦州","贵港","玉林","百色","贺州","河池","来宾","崇左"],
    "海南":["海口","三亚","五指山","琼海","儋州","文昌","万宁","东方","澄迈县","定安县","屯昌县","临高县","白沙黎族自治县"],
    "四川":["成都","自贡","攀枝花","泸州","德阳","绵阳","广元","遂宁","内江","乐山","南充","宜宾","广安","达州","眉山","雅安","巴中","资阳","阿坝州","甘孜州","凉山州"],
    "贵州":["贵阳","六盘水","遵义","安顺","铜仁","毕节","黔西南州","黔东南州","黔南州"],
    "云南":["昆明","曲靖","玉溪","保山","昭通","丽江","思茅","临沧","文山州","红河州","西双版纳州","楚雄州","大理州","德宏州","怒江州","迪庆州"],
    "西藏":["拉萨","那曲","昌都","山南","日喀则","阿里","林芝"],
    "陕西":["西安","铜川","宝鸡","咸阳","渭南","延安","汉中","榆林","安康","商洛"],
    "甘肃":["兰州","金昌","白银","天水","嘉峪关","武威","张掖","平凉","酒泉","庆阳","定西","陇南","临夏州","甘南州"],
    "宁夏":["银川","石嘴山","吴忠","固原","中卫"],
    "青海":["西宁","海东","海北州","黄南州","海南州","果洛州","玉树州","海西州"],
    "新疆":["乌鲁木齐","克拉玛依","吐鲁番","哈密","和田","阿克苏","喀什","克孜勒苏柯州","巴音郭楞州","昌吉州","博尔塔拉州","伊犁州","塔城","阿勒泰","石河子","阿拉尔"],
    "香港":["香港"],
    "澳门":["澳门"],
    "台湾":["台北","高雄","台中","花莲","基隆","嘉义","金门","连江","苗栗","南投","澎湖","屏东","台东","台南","桃园","新竹","宜兰","云林","彰化"]
}

应用程序=QApplication(sys.argv)
窗口=QMainWindow()
#窗口.setWindowFlag(Qt.FramelessWindowHint)
窗口.setWindowTitle("天气")
界面=QWidget()
窗口.setMinimumWidth(1080)
窗口.setMinimumHeight(1400)
窗口.setCentralWidget(界面)
窗口布局=QGridLayout()
界面.setLayout(窗口布局)

标签页=QTabWidget()
主页=QWidget()
主页布局=QGridLayout()
标签页.addTab(主页,"主页")
主页.setLayout(主页布局)
窗口布局.addWidget(标签页,10,0,1,2)

窗口.setStyleSheet(open(f"{sys.path[0]}/css.css","r").read())

菜单栏=QMenuBar()
窗口.setMenuBar(菜单栏)
文件菜单=菜单栏.addMenu("文件")
文件菜单.addAction("导出当前省份所有城市天气到Excel").triggered.connect(lambda: 导出天气.run())
帮助菜单=菜单栏.addMenu("帮助")


def 显示信息(标题,内容):
    临时窗口=QWidget()
    临时窗口.setWindowTitle(标题)
    临时窗口.setMinimumSize(QSize(480,480))
    临时窗口.setMaximumSize(QSize(640,800))
    临时窗口布局=QVBoxLayout()
    临时窗口.setLayout(临时窗口布局)
    临时文本框=QTextEdit()
    临时文本框.setHtml(内容)
    临时文本框.setReadOnly(True)
    临时窗口布局.addWidget(临时文本框)
    tmpButton=QPushButton("OK")
    tmpButton.clicked.connect(lambda: 临时窗口.destroy())
    临时窗口布局.addWidget(tmpButton)
    临时窗口.show()

def 显示许可证():
    许可证="""尽管软件是开源的，但是这个软件还是有版权！<br/>尽管软件是开源的，但是这个软件还是有版权！<br/>尽管软件是开源的，但是这个软件还是有版权！<br/>
<h3>The MIT License (MIT)</h3>
Copyright © 2022<br/>
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:<br/><br/>
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software<br/><br/>
THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE<br/><br/>"""
    显示信息("许可证",许可证)
帮助菜单.addAction("许可证").triggered.connect(显示许可证)

def 显示关于():
    关于="""天气信息来自于腾讯<br/>
    ZYH OS开发团队版权所有
    版本: 0.1Alpha
    """
    显示信息("关于",关于)
帮助菜单.addAction("关于").triggered.connect(显示关于)


窗口布局.addWidget(QLabel("选择地区:"),0,0,1,2)


def 城市选择器被改变():
    global 城市,接口
    城市=城市选择器.currentText()
    接口=f"https://wis.qq.com/weather/common?weather_type=observe|forecast_24h|forecast_1h|air|rise|index&source=pc&province={省份}&city={城市}"
    print(接口)

城市选择器=QComboBox()
窗口布局.addWidget(城市选择器,1,1)
城市选择器.activated[str].connect(城市选择器被改变)

当前城市列表=城市列表[省份]
def 省份选择器被改变():
    global 当前城市列表,省份,城市,接口
    省份=省份选择器.currentText()
    当前城市列表=城市列表[省份]
    城市选择器.clear()
    城市选择器.addItems(当前城市列表)
    城市=当前城市列表[0]
    接口=f"https://wis.qq.com/weather/common?weather_type=observe|forecast_24h|forecast_1h|air|rise|index&source=pc&province={省份}&city={城市}"

省份选择器=QComboBox()
省份列表=[]
for i in 城市列表:
    省份列表.append(i)

省份选择器.addItems(省份列表)
省份选择器.activated[str].connect(省份选择器被改变)
窗口布局.addWidget(省份选择器,1,0)
省份选择器.setCurrentText(省份)
城市选择器.addItems(城市列表[省份])
城市选择器.setCurrentText(城市)

class 获取天气进程程序(QThread):
    def __init__(self):
        super().__init__()
    def run(self):
        try:
            res=requests.get(url=接口,headers={"User-Agent":"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/108.0.0.0 Safari/537.36 Edg/108.0.1462.54"}).json()
            info=res["data"]["observe"]
            天气标签.setText(f"{城市}: {info['weather']} 风力{info['wind_power']}级")
            温湿度标签.setText(f"今日气温{info['degree']}℃ 湿度{info['humidity']}%")
            if os.path.exists(f"{sys.path[0]}/img/{info['weather']}.png"):天气图标.setPixmap(QPixmap(f"{sys.path[0]}/img/{info['weather']}.png"))
            else:天气图标.setPixmap(QPixmap(f"{sys.path[0]}/img/unknown.png"))
            air=res["data"]["air"]
            空气质量标签.setText(f"今日空气质量: {air['aqi']} {air['aqi_name']}")

            气温列表=[]
            最低温列表=[]
            最高温列表=[]
            _48小时风力列表=[]
            _7天白天风力列表=[]
            _7天晚上风力列表=[]
            
            
            forcast=res["data"]["forecast_24h"]
            forcast1h=res["data"]["forecast_1h"]
            for i in range(48):气温列表.append(int(forcast1h[str(i)]["degree"]))
            try:
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(9))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(8))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(7))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(6))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(5))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(4))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(3))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(2))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(1))
                未来天气信息布局.removeItem(未来天气信息布局.itemAt(0))

            except:pass

            未来天气信息布局.addWidget(QLabel("未来48小时气温图表:"))
            plt.style.use("dark_background")
            plt.cla()
            fig = plt.figure()
            ax =fig.add_axes([0.1,0.1,0.8,0.8])
            ax.plot(气温列表)
            cavans = FigureCanvas(fig)
            未来天气信息布局.addWidget(cavans)


            for i in range(8):
                最低温列表.append(int(forcast[str(i)]["min_degree"]))
                最高温列表.append(int(forcast[str(i)]["max_degree"]))
                

            未来天气信息布局.addWidget(QLabel("未来7天气温图表:"))
            plt.style.use("dark_background")
            fig2 = plt.figure()
            ax2 =fig2.add_axes([0.1,0.1,0.8,0.8])
            ax2.plot(最低温列表)
            ax2.plot(最高温列表)
            cavans2 = FigureCanvas(fig2)
            未来天气信息布局.addWidget(cavans2)


            for i in range(48):
                _48小时风力列表.append(int(forcast1h[str(i)]["wind_power"]))
                
                

            未来天气信息布局.addWidget(QLabel("未来48小时风力图表:"))
            plt.style.use("dark_background")
            fig3 = plt.figure()
            ax3 =fig3.add_axes([0.1,0.1,0.8,0.8])
            ax3.plot(_48小时风力列表)
            cavans3 = FigureCanvas(fig3)
            未来天气信息布局.addWidget(cavans3)


            for i in range(7):
                _7天白天风力列表.append(int(forcast[str(i)]["day_wind_power"]))
                _7天晚上风力列表.append(int(forcast[str(i)]["night_wind_power"]))
                
                
                

            未来天气信息布局.addWidget(QLabel("未来7天白天风力图表:"))
            plt.style.use("dark_background")
            fig4 = plt.figure()
            ax4 =fig4.add_axes([0.1,0.1,0.8,0.8])
            ax4.plot(_7天白天风力列表)
            
            cavans4 = FigureCanvas(fig4)
            未来天气信息布局.addWidget(cavans4)

            未来天气信息布局.addWidget(QLabel("未来7天晚上风力图表:"))
            plt.style.use("dark_background")
            fig5 = plt.figure()
            ax5 =fig5.add_axes([0.1,0.1,0.8,0.8])
            ax5.plot(_7天晚上风力列表)
            
            cavans5 = FigureCanvas(fig5)
            未来天气信息布局.addWidget(cavans5)

            


            

            天气表格=QTableWidget(8,4)
            天气表格.setHorizontalHeaderLabels(['日期','白天','夜晚','气温'])
            天气表格.horizontalHeader().setSectionResizeMode(QHeaderView.Stretch)
            天气表格.setEditTriggers(QAbstractItemView.NoEditTriggers)
            QTableWidget.resizeColumnsToContents(天气表格)
            QTableWidget.resizeRowsToContents(天气表格)
            天气表格.verticalHeader().setVisible(False)
            天气表格.setMinimumHeight(480)
            天气表格.setMaximumHeight(640)

            for i in range(8):
                天气表格.setItem(i,0,QTableWidgetItem(forcast[str(i)]["time"]))
                天气表格.setItem(i,1,QTableWidgetItem(forcast[str(i)]["day_weather"]+"  "+forcast[str(i)]["day_wind_direction"]+forcast[str(i)]["day_wind_power"]+"级"))
                天气表格.setItem(i,2,QTableWidgetItem(forcast[str(i)]["night_weather"]+"  "+forcast[str(i)]["night_wind_direction"]+forcast[str(i)]["night_wind_power"]+"级"))
                天气表格.setItem(i,3,QTableWidgetItem(forcast[str(i)]["min_degree"]+"℃ ~ "+forcast[str(i)]["max_degree"]+"℃"))

            主页布局.addWidget(QLabel("未来七天天气详细信息表格:"),6,0,1,2)
            主页布局.addWidget(天气表格,7,0,1,2)
            
            
            sun=res["data"]["rise"]
            for i in range(14):
                日出日落信息表.setItem(i,0,QTableWidgetItem(sun[str(i)]["time"][4:]))
                日出日落信息表.setItem(i,1,QTableWidgetItem(sun[str(i)]["sunrise"]))
                日出日落信息表.setItem(i,2,QTableWidgetItem(sun[str(i)]["sunset"]))
                            



            index=res["data"]["index"]
            del index["time"]
            del index["diffusion"]
            tmp=0
            for i in index:
                生活建议信息表.setItem(tmp,0,QTableWidgetItem(index[i]["name"]+" : "+index[i]["info"]+"    "+index[i]["detail"]))
                tmp+=1
        except:
            trace=traceback.format_exc()
            QMessageBox.critical(窗口,"错误",f"获取天气信息失败\n错误信息如下:\n{trace}",QMessageBox.Ok)

class 导出天气进程程序(QThread):
    def __init__(self):
        super().__init__()
    def run(self):
        try:
            savepath=QFileDialog.getSaveFileName(窗口,"保存文件","","Excel File(*.xls)")[0]
            if not savepath:
                QMessageBox.information(窗口,"信息","未选择路径已取消",QMessageBox.Ok)
                return
            表格x=xlwt.Workbook()
            for i in 当前城市列表:
                try:
                    res=requests.get(url=f"https://wis.qq.com/weather/common?weather_type=observe|forecast_24h|forecast_1h|air|rise&source=pc&province={省份}&city={i}",headers={"User-Agent":"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/108.0.0.0 Safari/537.36 Edg/108.0.1462.54"}).json()
                    日期列表=[]
                    forcast=res["data"]["forecast_24h"]
                    if not forcast:continue
                    表格=表格x.add_sheet(i)
                    for i in range(8):日期列表.append(forcast[str(i)]["time"][5:])
                    表格.write(0,0,"日期")
                    表格.write(0,1,"白天")
                    表格.write(0,2,"夜晚")
                    表格.write(0,3,"气温")
                    for i in range(8):
                        表格.write(i+1,0,日期列表[i])
                        表格.write(i+1,1,forcast[str(i)]["day_weather"]+"  "+forcast[str(i)]["day_wind_direction"]+forcast[str(i)]["day_wind_power"]+"级")
                        表格.write(i+1,2,forcast[str(i)]["night_weather"]+"  "+forcast[str(i)]["night_wind_direction"]+forcast[str(i)]["night_wind_power"]+"级")
                        表格.write(i+1,3,forcast[str(i)]["min_degree"]+"℃ ~ "+forcast[str(i)]["max_degree"]+"℃")
                except:continue
            表格x.save(savepath)
            QMessageBox.information(窗口,"信息","导出成功",QMessageBox.Ok)
        except:
            self.trace=traceback.format_exc()
            QMessageBox.critical(窗口,"错误",f"导出天气信息失败\n错误信息如下:\n{self.trace}",QMessageBox.Ok)

获取天气=获取天气进程程序()
导出天气=导出天气进程程序()

确定按钮=QPushButton("确定")
确定按钮.clicked.connect(lambda:获取天气.run())
窗口布局.addWidget(确定按钮,2,0,1,2)

今日天气区=QWidget()
主页布局.addWidget(今日天气区,3,0,1,2)
今日天气布局=QGridLayout()
今日天气区.setLayout(今日天气布局)


天气图标=QLabel()
今日天气布局.addWidget(天气图标,0,0,3,3)
温湿度标签=QLabel()
今日天气布局.addWidget(温湿度标签,0,3)
天气标签=QLabel()
今日天气布局.addWidget(天气标签,1,3)
空气质量标签=QLabel()
今日天气布局.addWidget(空气质量标签,2,3)

日出日落信息表=QTableWidget(14,3)
标签页.addTab(日出日落信息表,"日出日落")
日出日落信息表.setHorizontalHeaderLabels(['日期','日出','日落'])
日出日落信息表.horizontalHeader().setSectionResizeMode(QHeaderView.Stretch)
日出日落信息表.setEditTriggers(QAbstractItemView.NoEditTriggers)
QTableWidget.resizeColumnsToContents(日出日落信息表)
QTableWidget.resizeRowsToContents(日出日落信息表)
日出日落信息表.verticalHeader().setVisible(False)

生活建议信息表=QTableWidget(22,1)
标签页.addTab(生活建议信息表,"生活建议")
生活建议信息表.setHorizontalHeaderLabels(['项目'])
生活建议信息表.horizontalHeader().setSectionResizeMode(QHeaderView.Stretch)
生活建议信息表.setEditTriggers(QAbstractItemView.NoEditTriggers)
QTableWidget.resizeColumnsToContents(生活建议信息表)
QTableWidget.resizeRowsToContents(生活建议信息表)
生活建议信息表.verticalHeader().setVisible(False)

未来天气信息=QWidget()
未来天气信息布局=QVBoxLayout()
未来天气信息.setLayout(未来天气信息布局)
标签页.addTab(未来天气信息,"未来天气信息")

获取天气.run()
窗口.show()
#QMessageBox.information(窗口,"信息","开源不等于没有版权！\n"*20,QMessageBox.Ok)
os._exit(sys.exit(exit(应用程序.exec_())))